using System;
using System.Runtime.InteropServices;

namespace PkmnLibSharp.FFI.StaticData
{
    internal static class EffectParameter
    {
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr effect_parameter_new_bool(byte value);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr effect_parameter_new_int(long value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr effect_parameter_new_float(float value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IntPtr effect_parameter_new_string(IntPtr value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern void effect_parameter_drop(IntPtr value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern byte effect_parameter_get_type(IntPtr value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern byte effect_parameter_get_as_bool(IntPtr value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern long effect_parameter_get_as_int(IntPtr value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern float effect_parameter_get_as_float(IntPtr value);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr effect_parameter_get_as_string(IntPtr value);

    }
}