using System;
using System.Runtime.InteropServices;

using LevelInt = System.Byte;

namespace PkmnLibSharp.FFI.StaticData
{
    internal static class GrowthRate
    {
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IntPtr growth_rate_lookup_new(IntPtr array, ulong length);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern void growth_rate_lookup_drop(IntPtr p);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern LevelInt growth_rate_calculate_level(IntPtr p, uint experience);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern uint growth_rate_calculate_experience(IntPtr p, LevelInt level);
    }
}