using System;
using System.Runtime.InteropServices;
using PkmnLibSharp.StaticData;

namespace PkmnLibSharp.FFI.StaticData
{
    internal static class Nature
    {
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr nature_new(Statistic increaseStat, Statistic decreaseStat, float increaseModifier,
            float decreaseModifier);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern void nature_drop(IntPtr p);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern Statistic nature_increased_stat(IntPtr p);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern Statistic nature_decreased_stat(IntPtr p);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern float nature_get_stat_modifier(IntPtr p, Statistic statistic);
    }
}