using System;
using System.Runtime.InteropServices;

namespace PkmnLibSharp.FFI.StaticData
{
    internal static class Species
    {
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr species_new(ushort id, IntPtr name, float genderRate, IntPtr growthRate,
            byte captureRate, IntPtr defaultForm, IntPtr flags, ulong flagsLength);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern void species_drop(IntPtr ptr);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern ushort species_id(IntPtr ptr);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr species_name(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern float species_gender_rate(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr species_growth_rate(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern byte species_capture_rate(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr species_add_form(IntPtr ptr, IntPtr name, IntPtr form);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr species_get_form(IntPtr ptr, IntPtr name);

    }
}