using System;
using NUnit.Framework;
using PkmnLibSharp.StaticData;

namespace PkmnLibRSharpTests.StaticData
{
    public class SecondaryEffectTests
    {
        [Test]
        public void BasicTests(
            [Values(0, 100, 50, 22.5f)] float chance,
            [Values("foo", "bar", "", "ssdsdsdsdsd")] string effectName
        )
        {
            using var effect = new SecondaryEffect(chance, effectName, Array.Empty<EffectParameter>());
            Assert.AreEqual(effectName, effect.Name);
            Assert.AreEqual(chance, effect.Chance);
        }
    }
}