using System;
using System.Runtime.InteropServices;
using PkmnLibSharp.StaticData;

namespace PkmnLibSharp.FFI.StaticData
{
    internal static class Item
    {
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr item_new(IntPtr name, ItemCategory category, BattleItemCategory battleCategory,
            int price, IntPtr flags, ulong flagsLength);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern void item_drop(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern IntPtr item_name(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern ItemCategory item_category(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern BattleItemCategory item_battle_category(IntPtr ptr);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern int item_price(IntPtr ptr);

        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl)]
        internal static extern byte item_has_flag(IntPtr p, IntPtr flag);

    }
}