using System;
using System.Runtime.InteropServices;

namespace PkmnLibSharp.FFI.StaticData.Libraries
{
    internal static class SpeciesLibrary
    {
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IntPtr species_library_new(ulong capacity);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern void species_library_drop(IntPtr ptr);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern IntPtr species_library_get(IntPtr ptr, IntPtr key);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern void species_library_add(IntPtr ptr, IntPtr key, IntPtr value);
        
        [DllImport(Data.DllName, CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Ansi)]
        internal static extern ulong species_library_len(IntPtr ptr);
    }
}